# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::VMwareCloudSimple::Mgmt::V2019_04_01
  module Models
    #
    # Resource provider available operation model
    #
    class AvailableOperation

      include MsRestAzure

      # @return [AvailableOperationDisplay] The list of operations
      attr_accessor :display

      # @return [Boolean] Indicating whether the operation is a data action or
      # not. Default value: false .
      attr_accessor :is_data_action

      # @return [String]
      # {resourceProviderNamespace}/{resourceType}/{read|write|delete|action}
      attr_accessor :name

      # @return [OperationOrigin] The origin of operation. Possible values
      # include: 'user', 'system', 'user,system'
      attr_accessor :origin

      # @return
      # [AvailableOperationDisplayPropertyServiceSpecificationMetricsList] The
      # list of specification's service metrics
      attr_accessor :service_specification


      #
      # Mapper for AvailableOperation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AvailableOperation',
          type: {
            name: 'Composite',
            class_name: 'AvailableOperation',
            model_properties: {
              display: {
                client_side_validation: true,
                required: false,
                serialized_name: 'display',
                type: {
                  name: 'Composite',
                  class_name: 'AvailableOperationDisplay'
                }
              },
              is_data_action: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isDataAction',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              origin: {
                client_side_validation: true,
                required: false,
                serialized_name: 'origin',
                type: {
                  name: 'Enum',
                  module: 'OperationOrigin'
                }
              },
              service_specification: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serviceSpecification',
                type: {
                  name: 'Composite',
                  class_name: 'AvailableOperationDisplayPropertyServiceSpecificationMetricsList'
                }
              }
            }
          }
        }
      end
    end
  end
end
